<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *      http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> */<a name="line.16"></a>
<span class="sourceLineNo">017</span><a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import java.io.ByteArrayInputStream;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.nio.charset.StandardCharsets;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.sql.Connection;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.util.ArrayList;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.util.Arrays;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import java.util.Collection;<a name="line.25"></a>
<span class="sourceLineNo">026</span>import java.util.Enumeration;<a name="line.26"></a>
<span class="sourceLineNo">027</span>import java.util.Hashtable;<a name="line.27"></a>
<span class="sourceLineNo">028</span>import java.util.LinkedHashMap;<a name="line.28"></a>
<span class="sourceLineNo">029</span>import java.util.List;<a name="line.29"></a>
<span class="sourceLineNo">030</span>import java.util.Map;<a name="line.30"></a>
<span class="sourceLineNo">031</span>import java.util.Properties;<a name="line.31"></a>
<span class="sourceLineNo">032</span>import java.util.StringTokenizer;<a name="line.32"></a>
<span class="sourceLineNo">033</span><a name="line.33"></a>
<span class="sourceLineNo">034</span>import javax.naming.Context;<a name="line.34"></a>
<span class="sourceLineNo">035</span>import javax.naming.Name;<a name="line.35"></a>
<span class="sourceLineNo">036</span>import javax.naming.RefAddr;<a name="line.36"></a>
<span class="sourceLineNo">037</span>import javax.naming.Reference;<a name="line.37"></a>
<span class="sourceLineNo">038</span>import javax.naming.spi.ObjectFactory;<a name="line.38"></a>
<span class="sourceLineNo">039</span><a name="line.39"></a>
<span class="sourceLineNo">040</span>import org.apache.commons.logging.Log;<a name="line.40"></a>
<span class="sourceLineNo">041</span>import org.apache.commons.logging.LogFactory;<a name="line.41"></a>
<span class="sourceLineNo">042</span>import org.apache.commons.pool2.impl.BaseObjectPoolConfig;<a name="line.42"></a>
<span class="sourceLineNo">043</span>import org.apache.commons.pool2.impl.GenericObjectPoolConfig;<a name="line.43"></a>
<span class="sourceLineNo">044</span><a name="line.44"></a>
<span class="sourceLineNo">045</span>/**<a name="line.45"></a>
<span class="sourceLineNo">046</span> * &lt;p&gt;<a name="line.46"></a>
<span class="sourceLineNo">047</span> * JNDI object factory that creates an instance of &lt;code&gt;BasicDataSource&lt;/code&gt; that has been configured based on the<a name="line.47"></a>
<span class="sourceLineNo">048</span> * &lt;code&gt;RefAddr&lt;/code&gt; values of the specified &lt;code&gt;Reference&lt;/code&gt;, which must match the names and data types of the<a name="line.48"></a>
<span class="sourceLineNo">049</span> * &lt;code&gt;BasicDataSource&lt;/code&gt; bean properties with the following exceptions:<a name="line.49"></a>
<span class="sourceLineNo">050</span> * &lt;/p&gt;<a name="line.50"></a>
<span class="sourceLineNo">051</span> * &lt;ul&gt;<a name="line.51"></a>
<span class="sourceLineNo">052</span> * &lt;li&gt;&lt;code&gt;connectionInitSqls&lt;/code&gt; must be passed to this factory as a single String using semi-colon to delimit the<a name="line.52"></a>
<span class="sourceLineNo">053</span> * statements whereas &lt;code&gt;BasicDataSource&lt;/code&gt; requires a collection of Strings.&lt;/li&gt;<a name="line.53"></a>
<span class="sourceLineNo">054</span> * &lt;/ul&gt;<a name="line.54"></a>
<span class="sourceLineNo">055</span> *<a name="line.55"></a>
<span class="sourceLineNo">056</span> * @since 2.0<a name="line.56"></a>
<span class="sourceLineNo">057</span> */<a name="line.57"></a>
<span class="sourceLineNo">058</span>public class BasicDataSourceFactory implements ObjectFactory {<a name="line.58"></a>
<span class="sourceLineNo">059</span><a name="line.59"></a>
<span class="sourceLineNo">060</span>    private static final Log log = LogFactory.getLog(BasicDataSourceFactory.class);<a name="line.60"></a>
<span class="sourceLineNo">061</span><a name="line.61"></a>
<span class="sourceLineNo">062</span>    private static final String PROP_DEFAULT_AUTO_COMMIT = "defaultAutoCommit";<a name="line.62"></a>
<span class="sourceLineNo">063</span>    private static final String PROP_DEFAULT_READ_ONLY = "defaultReadOnly";<a name="line.63"></a>
<span class="sourceLineNo">064</span>    private static final String PROP_DEFAULT_TRANSACTION_ISOLATION = "defaultTransactionIsolation";<a name="line.64"></a>
<span class="sourceLineNo">065</span>    private static final String PROP_DEFAULT_CATALOG = "defaultCatalog";<a name="line.65"></a>
<span class="sourceLineNo">066</span>    private static final String PROP_DEFAULT_SCHEMA = "defaultSchema";<a name="line.66"></a>
<span class="sourceLineNo">067</span>    private static final String PROP_CACHE_STATE = "cacheState";<a name="line.67"></a>
<span class="sourceLineNo">068</span>    private static final String PROP_DRIVER_CLASS_NAME = "driverClassName";<a name="line.68"></a>
<span class="sourceLineNo">069</span>    private static final String PROP_LIFO = "lifo";<a name="line.69"></a>
<span class="sourceLineNo">070</span>    private static final String PROP_MAX_TOTAL = "maxTotal";<a name="line.70"></a>
<span class="sourceLineNo">071</span>    private static final String PROP_MAX_IDLE = "maxIdle";<a name="line.71"></a>
<span class="sourceLineNo">072</span>    private static final String PROP_MIN_IDLE = "minIdle";<a name="line.72"></a>
<span class="sourceLineNo">073</span>    private static final String PROP_INITIAL_SIZE = "initialSize";<a name="line.73"></a>
<span class="sourceLineNo">074</span>    private static final String PROP_MAX_WAIT_MILLIS = "maxWaitMillis";<a name="line.74"></a>
<span class="sourceLineNo">075</span>    private static final String PROP_TEST_ON_CREATE = "testOnCreate";<a name="line.75"></a>
<span class="sourceLineNo">076</span>    private static final String PROP_TEST_ON_BORROW = "testOnBorrow";<a name="line.76"></a>
<span class="sourceLineNo">077</span>    private static final String PROP_TEST_ON_RETURN = "testOnReturn";<a name="line.77"></a>
<span class="sourceLineNo">078</span>    private static final String PROP_TIME_BETWEEN_EVICTION_RUNS_MILLIS = "timeBetweenEvictionRunsMillis";<a name="line.78"></a>
<span class="sourceLineNo">079</span>    private static final String PROP_NUM_TESTS_PER_EVICTION_RUN = "numTestsPerEvictionRun";<a name="line.79"></a>
<span class="sourceLineNo">080</span>    private static final String PROP_MIN_EVICTABLE_IDLE_TIME_MILLIS = "minEvictableIdleTimeMillis";<a name="line.80"></a>
<span class="sourceLineNo">081</span>    private static final String PROP_SOFT_MIN_EVICTABLE_IDLE_TIME_MILLIS = "softMinEvictableIdleTimeMillis";<a name="line.81"></a>
<span class="sourceLineNo">082</span>    private static final String PROP_EVICTION_POLICY_CLASS_NAME = "evictionPolicyClassName";<a name="line.82"></a>
<span class="sourceLineNo">083</span>    private static final String PROP_TEST_WHILE_IDLE = "testWhileIdle";<a name="line.83"></a>
<span class="sourceLineNo">084</span>    private static final String PROP_PASSWORD = "password";<a name="line.84"></a>
<span class="sourceLineNo">085</span>    private static final String PROP_URL = "url";<a name="line.85"></a>
<span class="sourceLineNo">086</span>    private static final String PROP_USER_NAME = "username";<a name="line.86"></a>
<span class="sourceLineNo">087</span>    private static final String PROP_VALIDATION_QUERY = "validationQuery";<a name="line.87"></a>
<span class="sourceLineNo">088</span>    private static final String PROP_VALIDATION_QUERY_TIMEOUT = "validationQueryTimeout";<a name="line.88"></a>
<span class="sourceLineNo">089</span>    private static final String PROP_JMX_NAME = "jmxName";<a name="line.89"></a>
<span class="sourceLineNo">090</span>    private static final String PROP_CONNECTION_FACTORY_CLASS_NAME = "connectionFactoryClassName";<a name="line.90"></a>
<span class="sourceLineNo">091</span><a name="line.91"></a>
<span class="sourceLineNo">092</span>    /**<a name="line.92"></a>
<span class="sourceLineNo">093</span>     * The property name for connectionInitSqls. The associated value String must be of the form [query;]*<a name="line.93"></a>
<span class="sourceLineNo">094</span>     */<a name="line.94"></a>
<span class="sourceLineNo">095</span>    private static final String PROP_CONNECTION_INIT_SQLS = "connectionInitSqls";<a name="line.95"></a>
<span class="sourceLineNo">096</span>    private static final String PROP_ACCESS_TO_UNDERLYING_CONNECTION_ALLOWED = "accessToUnderlyingConnectionAllowed";<a name="line.96"></a>
<span class="sourceLineNo">097</span>    private static final String PROP_REMOVE_ABANDONED_ON_BORROW = "removeAbandonedOnBorrow";<a name="line.97"></a>
<span class="sourceLineNo">098</span>    private static final String PROP_REMOVE_ABANDONED_ON_MAINTENANCE = "removeAbandonedOnMaintenance";<a name="line.98"></a>
<span class="sourceLineNo">099</span>    private static final String PROP_REMOVE_ABANDONED_TIMEOUT = "removeAbandonedTimeout";<a name="line.99"></a>
<span class="sourceLineNo">100</span>    private static final String PROP_LOG_ABANDONED = "logAbandoned";<a name="line.100"></a>
<span class="sourceLineNo">101</span>    private static final String PROP_ABANDONED_USAGE_TRACKING = "abandonedUsageTracking";<a name="line.101"></a>
<span class="sourceLineNo">102</span>    private static final String PROP_POOL_PREPARED_STATEMENTS = "poolPreparedStatements";<a name="line.102"></a>
<span class="sourceLineNo">103</span>    private static final String PROP_CLEAR_STATEMENT_POOL_ON_RETURN = "clearStatementPoolOnReturn";<a name="line.103"></a>
<span class="sourceLineNo">104</span>    private static final String PROP_MAX_OPEN_PREPARED_STATEMENTS = "maxOpenPreparedStatements";<a name="line.104"></a>
<span class="sourceLineNo">105</span>    private static final String PROP_CONNECTION_PROPERTIES = "connectionProperties";<a name="line.105"></a>
<span class="sourceLineNo">106</span>    private static final String PROP_MAX_CONN_LIFETIME_MILLIS = "maxConnLifetimeMillis";<a name="line.106"></a>
<span class="sourceLineNo">107</span>    private static final String PROP_LOG_EXPIRED_CONNECTIONS = "logExpiredConnections";<a name="line.107"></a>
<span class="sourceLineNo">108</span>    private static final String PROP_ROLLBACK_ON_RETURN = "rollbackOnReturn";<a name="line.108"></a>
<span class="sourceLineNo">109</span>    private static final String PROP_ENABLE_AUTO_COMMIT_ON_RETURN = "enableAutoCommitOnReturn";<a name="line.109"></a>
<span class="sourceLineNo">110</span>    private static final String PROP_DEFAULT_QUERY_TIMEOUT = "defaultQueryTimeout";<a name="line.110"></a>
<span class="sourceLineNo">111</span>    private static final String PROP_FAST_FAIL_VALIDATION = "fastFailValidation";<a name="line.111"></a>
<span class="sourceLineNo">112</span><a name="line.112"></a>
<span class="sourceLineNo">113</span>    /**<a name="line.113"></a>
<span class="sourceLineNo">114</span>     * Value string must be of the form [STATE_CODE,]*<a name="line.114"></a>
<span class="sourceLineNo">115</span>     */<a name="line.115"></a>
<span class="sourceLineNo">116</span>    private static final String PROP_DISCONNECTION_SQL_CODES = "disconnectionSqlCodes";<a name="line.116"></a>
<span class="sourceLineNo">117</span><a name="line.117"></a>
<span class="sourceLineNo">118</span>    /*<a name="line.118"></a>
<span class="sourceLineNo">119</span>     * Block with obsolete properties from DBCP 1.x. Warn users that these are ignored and they should use the 2.x<a name="line.119"></a>
<span class="sourceLineNo">120</span>     * properties.<a name="line.120"></a>
<span class="sourceLineNo">121</span>     */<a name="line.121"></a>
<span class="sourceLineNo">122</span>    private static final String NUPROP_MAX_ACTIVE = "maxActive";<a name="line.122"></a>
<span class="sourceLineNo">123</span>    private static final String NUPROP_REMOVE_ABANDONED = "removeAbandoned";<a name="line.123"></a>
<span class="sourceLineNo">124</span>    private static final String NUPROP_MAXWAIT = "maxWait";<a name="line.124"></a>
<span class="sourceLineNo">125</span><a name="line.125"></a>
<span class="sourceLineNo">126</span>    /*<a name="line.126"></a>
<span class="sourceLineNo">127</span>     * Block with properties expected in a DataSource This props will not be listed as ignored - we know that they may<a name="line.127"></a>
<span class="sourceLineNo">128</span>     * appear in Resource, and not listing them as ignored.<a name="line.128"></a>
<span class="sourceLineNo">129</span>     */<a name="line.129"></a>
<span class="sourceLineNo">130</span>    private static final String SILENT_PROP_FACTORY = "factory";<a name="line.130"></a>
<span class="sourceLineNo">131</span>    private static final String SILENT_PROP_SCOPE = "scope";<a name="line.131"></a>
<span class="sourceLineNo">132</span>    private static final String SILENT_PROP_SINGLETON = "singleton";<a name="line.132"></a>
<span class="sourceLineNo">133</span>    private static final String SILENT_PROP_AUTH = "auth";<a name="line.133"></a>
<span class="sourceLineNo">134</span><a name="line.134"></a>
<span class="sourceLineNo">135</span>    private static final String[] ALL_PROPERTIES = {PROP_DEFAULT_AUTO_COMMIT, PROP_DEFAULT_READ_ONLY,<a name="line.135"></a>
<span class="sourceLineNo">136</span>            PROP_DEFAULT_TRANSACTION_ISOLATION, PROP_DEFAULT_CATALOG, PROP_DEFAULT_SCHEMA, PROP_CACHE_STATE,<a name="line.136"></a>
<span class="sourceLineNo">137</span>            PROP_DRIVER_CLASS_NAME, PROP_LIFO, PROP_MAX_TOTAL, PROP_MAX_IDLE, PROP_MIN_IDLE, PROP_INITIAL_SIZE,<a name="line.137"></a>
<span class="sourceLineNo">138</span>            PROP_MAX_WAIT_MILLIS, PROP_TEST_ON_CREATE, PROP_TEST_ON_BORROW, PROP_TEST_ON_RETURN,<a name="line.138"></a>
<span class="sourceLineNo">139</span>            PROP_TIME_BETWEEN_EVICTION_RUNS_MILLIS, PROP_NUM_TESTS_PER_EVICTION_RUN, PROP_MIN_EVICTABLE_IDLE_TIME_MILLIS,<a name="line.139"></a>
<span class="sourceLineNo">140</span>            PROP_SOFT_MIN_EVICTABLE_IDLE_TIME_MILLIS, PROP_EVICTION_POLICY_CLASS_NAME, PROP_TEST_WHILE_IDLE, PROP_PASSWORD,<a name="line.140"></a>
<span class="sourceLineNo">141</span>            PROP_URL, PROP_USER_NAME, PROP_VALIDATION_QUERY, PROP_VALIDATION_QUERY_TIMEOUT, PROP_CONNECTION_INIT_SQLS,<a name="line.141"></a>
<span class="sourceLineNo">142</span>            PROP_ACCESS_TO_UNDERLYING_CONNECTION_ALLOWED, PROP_REMOVE_ABANDONED_ON_BORROW, PROP_REMOVE_ABANDONED_ON_MAINTENANCE,<a name="line.142"></a>
<span class="sourceLineNo">143</span>            PROP_REMOVE_ABANDONED_TIMEOUT, PROP_LOG_ABANDONED, PROP_ABANDONED_USAGE_TRACKING, PROP_POOL_PREPARED_STATEMENTS,<a name="line.143"></a>
<span class="sourceLineNo">144</span>            PROP_CLEAR_STATEMENT_POOL_ON_RETURN,<a name="line.144"></a>
<span class="sourceLineNo">145</span>            PROP_MAX_OPEN_PREPARED_STATEMENTS, PROP_CONNECTION_PROPERTIES, PROP_MAX_CONN_LIFETIME_MILLIS,<a name="line.145"></a>
<span class="sourceLineNo">146</span>            PROP_LOG_EXPIRED_CONNECTIONS, PROP_ROLLBACK_ON_RETURN, PROP_ENABLE_AUTO_COMMIT_ON_RETURN,<a name="line.146"></a>
<span class="sourceLineNo">147</span>            PROP_DEFAULT_QUERY_TIMEOUT, PROP_FAST_FAIL_VALIDATION, PROP_DISCONNECTION_SQL_CODES, PROP_JMX_NAME,<a name="line.147"></a>
<span class="sourceLineNo">148</span>            PROP_CONNECTION_FACTORY_CLASS_NAME };<a name="line.148"></a>
<span class="sourceLineNo">149</span><a name="line.149"></a>
<span class="sourceLineNo">150</span>    /**<a name="line.150"></a>
<span class="sourceLineNo">151</span>     * Obsolete properties from DBCP 1.x. with warning strings suggesting new properties. LinkedHashMap will guarantee<a name="line.151"></a>
<span class="sourceLineNo">152</span>     * that properties will be listed to output in order of insertion into map.<a name="line.152"></a>
<span class="sourceLineNo">153</span>     */<a name="line.153"></a>
<span class="sourceLineNo">154</span>    private static final Map&lt;String, String&gt; NUPROP_WARNTEXT = new LinkedHashMap&lt;&gt;();<a name="line.154"></a>
<span class="sourceLineNo">155</span><a name="line.155"></a>
<span class="sourceLineNo">156</span>    static {<a name="line.156"></a>
<span class="sourceLineNo">157</span>        NUPROP_WARNTEXT.put(NUPROP_MAX_ACTIVE,<a name="line.157"></a>
<span class="sourceLineNo">158</span>                "Property " + NUPROP_MAX_ACTIVE + " is not used in DBCP2, use " + PROP_MAX_TOTAL + " instead. "<a name="line.158"></a>
<span class="sourceLineNo">159</span>                        + PROP_MAX_TOTAL + " default value is " + GenericObjectPoolConfig.DEFAULT_MAX_TOTAL + ".");<a name="line.159"></a>
<span class="sourceLineNo">160</span>        NUPROP_WARNTEXT.put(NUPROP_REMOVE_ABANDONED,<a name="line.160"></a>
<span class="sourceLineNo">161</span>                "Property " + NUPROP_REMOVE_ABANDONED + " is not used in DBCP2," + " use one or both of "<a name="line.161"></a>
<span class="sourceLineNo">162</span>                        + PROP_REMOVE_ABANDONED_ON_BORROW + " or " + PROP_REMOVE_ABANDONED_ON_MAINTENANCE + " instead. "<a name="line.162"></a>
<span class="sourceLineNo">163</span>                        + "Both have default value set to false.");<a name="line.163"></a>
<span class="sourceLineNo">164</span>        NUPROP_WARNTEXT.put(NUPROP_MAXWAIT,<a name="line.164"></a>
<span class="sourceLineNo">165</span>                "Property " + NUPROP_MAXWAIT + " is not used in DBCP2" + " , use " + PROP_MAX_WAIT_MILLIS + " instead. "<a name="line.165"></a>
<span class="sourceLineNo">166</span>                        + PROP_MAX_WAIT_MILLIS + " default value is " + BaseObjectPoolConfig.DEFAULT_MAX_WAIT_MILLIS<a name="line.166"></a>
<span class="sourceLineNo">167</span>                        + ".");<a name="line.167"></a>
<span class="sourceLineNo">168</span>    }<a name="line.168"></a>
<span class="sourceLineNo">169</span><a name="line.169"></a>
<span class="sourceLineNo">170</span>    /**<a name="line.170"></a>
<span class="sourceLineNo">171</span>     * Silent Properties. These properties will not be listed as ignored - we know that they may appear in JDBC Resource<a name="line.171"></a>
<span class="sourceLineNo">172</span>     * references, and we will not list them as ignored.<a name="line.172"></a>
<span class="sourceLineNo">173</span>     */<a name="line.173"></a>
<span class="sourceLineNo">174</span>    private static final List&lt;String&gt; SILENT_PROPERTIES = new ArrayList&lt;&gt;();<a name="line.174"></a>
<span class="sourceLineNo">175</span><a name="line.175"></a>
<span class="sourceLineNo">176</span>    static {<a name="line.176"></a>
<span class="sourceLineNo">177</span>        SILENT_PROPERTIES.add(SILENT_PROP_FACTORY);<a name="line.177"></a>
<span class="sourceLineNo">178</span>        SILENT_PROPERTIES.add(SILENT_PROP_SCOPE);<a name="line.178"></a>
<span class="sourceLineNo">179</span>        SILENT_PROPERTIES.add(SILENT_PROP_SINGLETON);<a name="line.179"></a>
<span class="sourceLineNo">180</span>        SILENT_PROPERTIES.add(SILENT_PROP_AUTH);<a name="line.180"></a>
<span class="sourceLineNo">181</span><a name="line.181"></a>
<span class="sourceLineNo">182</span>    }<a name="line.182"></a>
<span class="sourceLineNo">183</span><a name="line.183"></a>
<span class="sourceLineNo">184</span>    // -------------------------------------------------- ObjectFactory Methods<a name="line.184"></a>
<span class="sourceLineNo">185</span><a name="line.185"></a>
<span class="sourceLineNo">186</span>    /**<a name="line.186"></a>
<span class="sourceLineNo">187</span>     * &lt;p&gt;<a name="line.187"></a>
<span class="sourceLineNo">188</span>     * Create and return a new &lt;code&gt;BasicDataSource&lt;/code&gt; instance. If no instance can be created, return<a name="line.188"></a>
<span class="sourceLineNo">189</span>     * &lt;code&gt;null&lt;/code&gt; instead.<a name="line.189"></a>
<span class="sourceLineNo">190</span>     * &lt;/p&gt;<a name="line.190"></a>
<span class="sourceLineNo">191</span>     *<a name="line.191"></a>
<span class="sourceLineNo">192</span>     * @param obj<a name="line.192"></a>
<span class="sourceLineNo">193</span>     *            The possibly null object containing location or reference information that can be used in creating an<a name="line.193"></a>
<span class="sourceLineNo">194</span>     *            object<a name="line.194"></a>
<span class="sourceLineNo">195</span>     * @param name<a name="line.195"></a>
<span class="sourceLineNo">196</span>     *            The name of this object relative to &lt;code&gt;nameCtx&lt;/code&gt;<a name="line.196"></a>
<span class="sourceLineNo">197</span>     * @param nameCtx<a name="line.197"></a>
<span class="sourceLineNo">198</span>     *            The context relative to which the &lt;code&gt;name&lt;/code&gt; parameter is specified, or &lt;code&gt;null&lt;/code&gt; if<a name="line.198"></a>
<span class="sourceLineNo">199</span>     *            &lt;code&gt;name&lt;/code&gt; is relative to the default initial context<a name="line.199"></a>
<span class="sourceLineNo">200</span>     * @param environment<a name="line.200"></a>
<span class="sourceLineNo">201</span>     *            The possibly null environment that is used in creating this object<a name="line.201"></a>
<span class="sourceLineNo">202</span>     *<a name="line.202"></a>
<span class="sourceLineNo">203</span>     * @throws Exception<a name="line.203"></a>
<span class="sourceLineNo">204</span>     *             if an exception occurs creating the instance<a name="line.204"></a>
<span class="sourceLineNo">205</span>     */<a name="line.205"></a>
<span class="sourceLineNo">206</span>    @Override<a name="line.206"></a>
<span class="sourceLineNo">207</span>    public Object getObjectInstance(final Object obj, final Name name, final Context nameCtx,<a name="line.207"></a>
<span class="sourceLineNo">208</span>            final Hashtable&lt;?, ?&gt; environment) throws Exception {<a name="line.208"></a>
<span class="sourceLineNo">209</span><a name="line.209"></a>
<span class="sourceLineNo">210</span>        // We only know how to deal with &lt;code&gt;javax.naming.Reference&lt;/code&gt;s<a name="line.210"></a>
<span class="sourceLineNo">211</span>        // that specify a class name of "javax.sql.DataSource"<a name="line.211"></a>
<span class="sourceLineNo">212</span>        if (obj == null || !(obj instanceof Reference)) {<a name="line.212"></a>
<span class="sourceLineNo">213</span>            return null;<a name="line.213"></a>
<span class="sourceLineNo">214</span>        }<a name="line.214"></a>
<span class="sourceLineNo">215</span>        final Reference ref = (Reference) obj;<a name="line.215"></a>
<span class="sourceLineNo">216</span>        if (!"javax.sql.DataSource".equals(ref.getClassName())) {<a name="line.216"></a>
<span class="sourceLineNo">217</span>            return null;<a name="line.217"></a>
<span class="sourceLineNo">218</span>        }<a name="line.218"></a>
<span class="sourceLineNo">219</span><a name="line.219"></a>
<span class="sourceLineNo">220</span>        // Check property names and log warnings about obsolete and / or unknown properties<a name="line.220"></a>
<span class="sourceLineNo">221</span>        final List&lt;String&gt; warnings = new ArrayList&lt;&gt;();<a name="line.221"></a>
<span class="sourceLineNo">222</span>        final List&lt;String&gt; infoMessages = new ArrayList&lt;&gt;();<a name="line.222"></a>
<span class="sourceLineNo">223</span>        validatePropertyNames(ref, name, warnings, infoMessages);<a name="line.223"></a>
<span class="sourceLineNo">224</span>        for (final String warning : warnings) {<a name="line.224"></a>
<span class="sourceLineNo">225</span>            log.warn(warning);<a name="line.225"></a>
<span class="sourceLineNo">226</span>        }<a name="line.226"></a>
<span class="sourceLineNo">227</span>        for (final String infoMessage : infoMessages) {<a name="line.227"></a>
<span class="sourceLineNo">228</span>            log.info(infoMessage);<a name="line.228"></a>
<span class="sourceLineNo">229</span>        }<a name="line.229"></a>
<span class="sourceLineNo">230</span><a name="line.230"></a>
<span class="sourceLineNo">231</span>        final Properties properties = new Properties();<a name="line.231"></a>
<span class="sourceLineNo">232</span>        for (final String propertyName : ALL_PROPERTIES) {<a name="line.232"></a>
<span class="sourceLineNo">233</span>            final RefAddr ra = ref.get(propertyName);<a name="line.233"></a>
<span class="sourceLineNo">234</span>            if (ra != null) {<a name="line.234"></a>
<span class="sourceLineNo">235</span>                final String propertyValue = ra.getContent().toString();<a name="line.235"></a>
<span class="sourceLineNo">236</span>                properties.setProperty(propertyName, propertyValue);<a name="line.236"></a>
<span class="sourceLineNo">237</span>            }<a name="line.237"></a>
<span class="sourceLineNo">238</span>        }<a name="line.238"></a>
<span class="sourceLineNo">239</span><a name="line.239"></a>
<span class="sourceLineNo">240</span>        return createDataSource(properties);<a name="line.240"></a>
<span class="sourceLineNo">241</span>    }<a name="line.241"></a>
<span class="sourceLineNo">242</span><a name="line.242"></a>
<span class="sourceLineNo">243</span>    /**<a name="line.243"></a>
<span class="sourceLineNo">244</span>     * Collects warnings and info messages. Warnings are generated when an obsolete property is set. Unknown properties<a name="line.244"></a>
<span class="sourceLineNo">245</span>     * generate info messages.<a name="line.245"></a>
<span class="sourceLineNo">246</span>     *<a name="line.246"></a>
<span class="sourceLineNo">247</span>     * @param ref<a name="line.247"></a>
<span class="sourceLineNo">248</span>     *            Reference to check properties of<a name="line.248"></a>
<span class="sourceLineNo">249</span>     * @param name<a name="line.249"></a>
<span class="sourceLineNo">250</span>     *            Name provided to getObject<a name="line.250"></a>
<span class="sourceLineNo">251</span>     * @param warnings<a name="line.251"></a>
<span class="sourceLineNo">252</span>     *            container for warning messages<a name="line.252"></a>
<span class="sourceLineNo">253</span>     * @param infoMessages<a name="line.253"></a>
<span class="sourceLineNo">254</span>     *            container for info messages<a name="line.254"></a>
<span class="sourceLineNo">255</span>     */<a name="line.255"></a>
<span class="sourceLineNo">256</span>    private void validatePropertyNames(final Reference ref, final Name name, final List&lt;String&gt; warnings,<a name="line.256"></a>
<span class="sourceLineNo">257</span>            final List&lt;String&gt; infoMessages) {<a name="line.257"></a>
<span class="sourceLineNo">258</span>        final List&lt;String&gt; allPropsAsList = Arrays.asList(ALL_PROPERTIES);<a name="line.258"></a>
<span class="sourceLineNo">259</span>        final String nameString = name != null ? "Name = " + name.toString() + " " : "";<a name="line.259"></a>
<span class="sourceLineNo">260</span>        if (NUPROP_WARNTEXT != null &amp;&amp; !NUPROP_WARNTEXT.isEmpty()) {<a name="line.260"></a>
<span class="sourceLineNo">261</span>            for (final String propertyName : NUPROP_WARNTEXT.keySet()) {<a name="line.261"></a>
<span class="sourceLineNo">262</span>                final RefAddr ra = ref.get(propertyName);<a name="line.262"></a>
<span class="sourceLineNo">263</span>                if (ra != null &amp;&amp; !allPropsAsList.contains(ra.getType())) {<a name="line.263"></a>
<span class="sourceLineNo">264</span>                    final StringBuilder stringBuilder = new StringBuilder(nameString);<a name="line.264"></a>
<span class="sourceLineNo">265</span>                    final String propertyValue = ra.getContent().toString();<a name="line.265"></a>
<span class="sourceLineNo">266</span>                    stringBuilder.append(NUPROP_WARNTEXT.get(propertyName)).append(" You have set value of \"")<a name="line.266"></a>
<span class="sourceLineNo">267</span>                            .append(propertyValue).append("\" for \"").append(propertyName)<a name="line.267"></a>
<span class="sourceLineNo">268</span>                            .append("\" property, which is being ignored.");<a name="line.268"></a>
<span class="sourceLineNo">269</span>                    warnings.add(stringBuilder.toString());<a name="line.269"></a>
<span class="sourceLineNo">270</span>                }<a name="line.270"></a>
<span class="sourceLineNo">271</span>            }<a name="line.271"></a>
<span class="sourceLineNo">272</span>        }<a name="line.272"></a>
<span class="sourceLineNo">273</span><a name="line.273"></a>
<span class="sourceLineNo">274</span>        final Enumeration&lt;RefAddr&gt; allRefAddrs = ref.getAll();<a name="line.274"></a>
<span class="sourceLineNo">275</span>        while (allRefAddrs.hasMoreElements()) {<a name="line.275"></a>
<span class="sourceLineNo">276</span>            final RefAddr ra = allRefAddrs.nextElement();<a name="line.276"></a>
<span class="sourceLineNo">277</span>            final String propertyName = ra.getType();<a name="line.277"></a>
<span class="sourceLineNo">278</span>            // If property name is not in the properties list, we haven't warned on it<a name="line.278"></a>
<span class="sourceLineNo">279</span>            // and it is not in the "silent" list, tell user we are ignoring it.<a name="line.279"></a>
<span class="sourceLineNo">280</span>            if (!(allPropsAsList.contains(propertyName) || NUPROP_WARNTEXT.containsKey(propertyName)<a name="line.280"></a>
<span class="sourceLineNo">281</span>                    || SILENT_PROPERTIES.contains(propertyName))) {<a name="line.281"></a>
<span class="sourceLineNo">282</span>                final String propertyValue = ra.getContent().toString();<a name="line.282"></a>
<span class="sourceLineNo">283</span>                final StringBuilder stringBuilder = new StringBuilder(nameString);<a name="line.283"></a>
<span class="sourceLineNo">284</span>                stringBuilder.append("Ignoring unknown property: ").append("value of \"").append(propertyValue)<a name="line.284"></a>
<span class="sourceLineNo">285</span>                        .append("\" for \"").append(propertyName).append("\" property");<a name="line.285"></a>
<span class="sourceLineNo">286</span>                infoMessages.add(stringBuilder.toString());<a name="line.286"></a>
<span class="sourceLineNo">287</span>            }<a name="line.287"></a>
<span class="sourceLineNo">288</span>        }<a name="line.288"></a>
<span class="sourceLineNo">289</span>    }<a name="line.289"></a>
<span class="sourceLineNo">290</span><a name="line.290"></a>
<span class="sourceLineNo">291</span>    /**<a name="line.291"></a>
<span class="sourceLineNo">292</span>     * Creates and configures a {@link BasicDataSource} instance based on the given properties.<a name="line.292"></a>
<span class="sourceLineNo">293</span>     *<a name="line.293"></a>
<span class="sourceLineNo">294</span>     * @param properties<a name="line.294"></a>
<span class="sourceLineNo">295</span>     *            The data source configuration properties.<a name="line.295"></a>
<span class="sourceLineNo">296</span>     * @return A new a {@link BasicDataSource} instance based on the given properties.<a name="line.296"></a>
<span class="sourceLineNo">297</span>     * @throws Exception<a name="line.297"></a>
<span class="sourceLineNo">298</span>     *             Thrown when an error occurs creating the data source.<a name="line.298"></a>
<span class="sourceLineNo">299</span>     */<a name="line.299"></a>
<span class="sourceLineNo">300</span>    public static BasicDataSource createDataSource(final Properties properties) throws Exception {<a name="line.300"></a>
<span class="sourceLineNo">301</span>        final BasicDataSource dataSource = new BasicDataSource();<a name="line.301"></a>
<span class="sourceLineNo">302</span>        String value = null;<a name="line.302"></a>
<span class="sourceLineNo">303</span><a name="line.303"></a>
<span class="sourceLineNo">304</span>        value = properties.getProperty(PROP_DEFAULT_AUTO_COMMIT);<a name="line.304"></a>
<span class="sourceLineNo">305</span>        if (value != null) {<a name="line.305"></a>
<span class="sourceLineNo">306</span>            dataSource.setDefaultAutoCommit(Boolean.valueOf(value));<a name="line.306"></a>
<span class="sourceLineNo">307</span>        }<a name="line.307"></a>
<span class="sourceLineNo">308</span><a name="line.308"></a>
<span class="sourceLineNo">309</span>        value = properties.getProperty(PROP_DEFAULT_READ_ONLY);<a name="line.309"></a>
<span class="sourceLineNo">310</span>        if (value != null) {<a name="line.310"></a>
<span class="sourceLineNo">311</span>            dataSource.setDefaultReadOnly(Boolean.valueOf(value));<a name="line.311"></a>
<span class="sourceLineNo">312</span>        }<a name="line.312"></a>
<span class="sourceLineNo">313</span><a name="line.313"></a>
<span class="sourceLineNo">314</span>        value = properties.getProperty(PROP_DEFAULT_TRANSACTION_ISOLATION);<a name="line.314"></a>
<span class="sourceLineNo">315</span>        if (value != null) {<a name="line.315"></a>
<span class="sourceLineNo">316</span>            int level = PoolableConnectionFactory.UNKNOWN_TRANSACTION_ISOLATION;<a name="line.316"></a>
<span class="sourceLineNo">317</span>            if ("NONE".equalsIgnoreCase(value)) {<a name="line.317"></a>
<span class="sourceLineNo">318</span>                level = Connection.TRANSACTION_NONE;<a name="line.318"></a>
<span class="sourceLineNo">319</span>            } else if ("READ_COMMITTED".equalsIgnoreCase(value)) {<a name="line.319"></a>
<span class="sourceLineNo">320</span>                level = Connection.TRANSACTION_READ_COMMITTED;<a name="line.320"></a>
<span class="sourceLineNo">321</span>            } else if ("READ_UNCOMMITTED".equalsIgnoreCase(value)) {<a name="line.321"></a>
<span class="sourceLineNo">322</span>                level = Connection.TRANSACTION_READ_UNCOMMITTED;<a name="line.322"></a>
<span class="sourceLineNo">323</span>            } else if ("REPEATABLE_READ".equalsIgnoreCase(value)) {<a name="line.323"></a>
<span class="sourceLineNo">324</span>                level = Connection.TRANSACTION_REPEATABLE_READ;<a name="line.324"></a>
<span class="sourceLineNo">325</span>            } else if ("SERIALIZABLE".equalsIgnoreCase(value)) {<a name="line.325"></a>
<span class="sourceLineNo">326</span>                level = Connection.TRANSACTION_SERIALIZABLE;<a name="line.326"></a>
<span class="sourceLineNo">327</span>            } else {<a name="line.327"></a>
<span class="sourceLineNo">328</span>                try {<a name="line.328"></a>
<span class="sourceLineNo">329</span>                    level = Integer.parseInt(value);<a name="line.329"></a>
<span class="sourceLineNo">330</span>                } catch (final NumberFormatException e) {<a name="line.330"></a>
<span class="sourceLineNo">331</span>                    System.err.println("Could not parse defaultTransactionIsolation: " + value);<a name="line.331"></a>
<span class="sourceLineNo">332</span>                    System.err.println("WARNING: defaultTransactionIsolation not set");<a name="line.332"></a>
<span class="sourceLineNo">333</span>                    System.err.println("using default value of database driver");<a name="line.333"></a>
<span class="sourceLineNo">334</span>                    level = PoolableConnectionFactory.UNKNOWN_TRANSACTION_ISOLATION;<a name="line.334"></a>
<span class="sourceLineNo">335</span>                }<a name="line.335"></a>
<span class="sourceLineNo">336</span>            }<a name="line.336"></a>
<span class="sourceLineNo">337</span>            dataSource.setDefaultTransactionIsolation(level);<a name="line.337"></a>
<span class="sourceLineNo">338</span>        }<a name="line.338"></a>
<span class="sourceLineNo">339</span><a name="line.339"></a>
<span class="sourceLineNo">340</span>        value = properties.getProperty(PROP_DEFAULT_CATALOG);<a name="line.340"></a>
<span class="sourceLineNo">341</span>        if (value != null) {<a name="line.341"></a>
<span class="sourceLineNo">342</span>            dataSource.setDefaultCatalog(value);<a name="line.342"></a>
<span class="sourceLineNo">343</span>        }<a name="line.343"></a>
<span class="sourceLineNo">344</span><a name="line.344"></a>
<span class="sourceLineNo">345</span>        value = properties.getProperty(PROP_DEFAULT_SCHEMA);<a name="line.345"></a>
<span class="sourceLineNo">346</span>        if (value != null) {<a name="line.346"></a>
<span class="sourceLineNo">347</span>            dataSource.setDefaultSchema(value);<a name="line.347"></a>
<span class="sourceLineNo">348</span>        }<a name="line.348"></a>
<span class="sourceLineNo">349</span><a name="line.349"></a>
<span class="sourceLineNo">350</span>        value = properties.getProperty(PROP_CACHE_STATE);<a name="line.350"></a>
<span class="sourceLineNo">351</span>        if (value != null) {<a name="line.351"></a>
<span class="sourceLineNo">352</span>            dataSource.setCacheState(Boolean.valueOf(value).booleanValue());<a name="line.352"></a>
<span class="sourceLineNo">353</span>        }<a name="line.353"></a>
<span class="sourceLineNo">354</span><a name="line.354"></a>
<span class="sourceLineNo">355</span>        value = properties.getProperty(PROP_DRIVER_CLASS_NAME);<a name="line.355"></a>
<span class="sourceLineNo">356</span>        if (value != null) {<a name="line.356"></a>
<span class="sourceLineNo">357</span>            dataSource.setDriverClassName(value);<a name="line.357"></a>
<span class="sourceLineNo">358</span>        }<a name="line.358"></a>
<span class="sourceLineNo">359</span><a name="line.359"></a>
<span class="sourceLineNo">360</span>        value = properties.getProperty(PROP_LIFO);<a name="line.360"></a>
<span class="sourceLineNo">361</span>        if (value != null) {<a name="line.361"></a>
<span class="sourceLineNo">362</span>            dataSource.setLifo(Boolean.valueOf(value).booleanValue());<a name="line.362"></a>
<span class="sourceLineNo">363</span>        }<a name="line.363"></a>
<span class="sourceLineNo">364</span><a name="line.364"></a>
<span class="sourceLineNo">365</span>        value = properties.getProperty(PROP_MAX_TOTAL);<a name="line.365"></a>
<span class="sourceLineNo">366</span>        if (value != null) {<a name="line.366"></a>
<span class="sourceLineNo">367</span>            dataSource.setMaxTotal(Integer.parseInt(value));<a name="line.367"></a>
<span class="sourceLineNo">368</span>        }<a name="line.368"></a>
<span class="sourceLineNo">369</span><a name="line.369"></a>
<span class="sourceLineNo">370</span>        value = properties.getProperty(PROP_MAX_IDLE);<a name="line.370"></a>
<span class="sourceLineNo">371</span>        if (value != null) {<a name="line.371"></a>
<span class="sourceLineNo">372</span>            dataSource.setMaxIdle(Integer.parseInt(value));<a name="line.372"></a>
<span class="sourceLineNo">373</span>        }<a name="line.373"></a>
<span class="sourceLineNo">374</span><a name="line.374"></a>
<span class="sourceLineNo">375</span>        value = properties.getProperty(PROP_MIN_IDLE);<a name="line.375"></a>
<span class="sourceLineNo">376</span>        if (value != null) {<a name="line.376"></a>
<span class="sourceLineNo">377</span>            dataSource.setMinIdle(Integer.parseInt(value));<a name="line.377"></a>
<span class="sourceLineNo">378</span>        }<a name="line.378"></a>
<span class="sourceLineNo">379</span><a name="line.379"></a>
<span class="sourceLineNo">380</span>        value = properties.getProperty(PROP_INITIAL_SIZE);<a name="line.380"></a>
<span class="sourceLineNo">381</span>        if (value != null) {<a name="line.381"></a>
<span class="sourceLineNo">382</span>            dataSource.setInitialSize(Integer.parseInt(value));<a name="line.382"></a>
<span class="sourceLineNo">383</span>        }<a name="line.383"></a>
<span class="sourceLineNo">384</span><a name="line.384"></a>
<span class="sourceLineNo">385</span>        value = properties.getProperty(PROP_MAX_WAIT_MILLIS);<a name="line.385"></a>
<span class="sourceLineNo">386</span>        if (value != null) {<a name="line.386"></a>
<span class="sourceLineNo">387</span>            dataSource.setMaxWaitMillis(Long.parseLong(value));<a name="line.387"></a>
<span class="sourceLineNo">388</span>        }<a name="line.388"></a>
<span class="sourceLineNo">389</span><a name="line.389"></a>
<span class="sourceLineNo">390</span>        value = properties.getProperty(PROP_TEST_ON_CREATE);<a name="line.390"></a>
<span class="sourceLineNo">391</span>        if (value != null) {<a name="line.391"></a>
<span class="sourceLineNo">392</span>            dataSource.setTestOnCreate(Boolean.valueOf(value).booleanValue());<a name="line.392"></a>
<span class="sourceLineNo">393</span>        }<a name="line.393"></a>
<span class="sourceLineNo">394</span><a name="line.394"></a>
<span class="sourceLineNo">395</span>        value = properties.getProperty(PROP_TEST_ON_BORROW);<a name="line.395"></a>
<span class="sourceLineNo">396</span>        if (value != null) {<a name="line.396"></a>
<span class="sourceLineNo">397</span>            dataSource.setTestOnBorrow(Boolean.valueOf(value).booleanValue());<a name="line.397"></a>
<span class="sourceLineNo">398</span>        }<a name="line.398"></a>
<span class="sourceLineNo">399</span><a name="line.399"></a>
<span class="sourceLineNo">400</span>        value = properties.getProperty(PROP_TEST_ON_RETURN);<a name="line.400"></a>
<span class="sourceLineNo">401</span>        if (value != null) {<a name="line.401"></a>
<span class="sourceLineNo">402</span>            dataSource.setTestOnReturn(Boolean.valueOf(value).booleanValue());<a name="line.402"></a>
<span class="sourceLineNo">403</span>        }<a name="line.403"></a>
<span class="sourceLineNo">404</span><a name="line.404"></a>
<span class="sourceLineNo">405</span>        value = properties.getProperty(PROP_TIME_BETWEEN_EVICTION_RUNS_MILLIS);<a name="line.405"></a>
<span class="sourceLineNo">406</span>        if (value != null) {<a name="line.406"></a>
<span class="sourceLineNo">407</span>            dataSource.setTimeBetweenEvictionRunsMillis(Long.parseLong(value));<a name="line.407"></a>
<span class="sourceLineNo">408</span>        }<a name="line.408"></a>
<span class="sourceLineNo">409</span><a name="line.409"></a>
<span class="sourceLineNo">410</span>        value = properties.getProperty(PROP_NUM_TESTS_PER_EVICTION_RUN);<a name="line.410"></a>
<span class="sourceLineNo">411</span>        if (value != null) {<a name="line.411"></a>
<span class="sourceLineNo">412</span>            dataSource.setNumTestsPerEvictionRun(Integer.parseInt(value));<a name="line.412"></a>
<span class="sourceLineNo">413</span>        }<a name="line.413"></a>
<span class="sourceLineNo">414</span><a name="line.414"></a>
<span class="sourceLineNo">415</span>        value = properties.getProperty(PROP_MIN_EVICTABLE_IDLE_TIME_MILLIS);<a name="line.415"></a>
<span class="sourceLineNo">416</span>        if (value != null) {<a name="line.416"></a>
<span class="sourceLineNo">417</span>            dataSource.setMinEvictableIdleTimeMillis(Long.parseLong(value));<a name="line.417"></a>
<span class="sourceLineNo">418</span>        }<a name="line.418"></a>
<span class="sourceLineNo">419</span><a name="line.419"></a>
<span class="sourceLineNo">420</span>        value = properties.getProperty(PROP_SOFT_MIN_EVICTABLE_IDLE_TIME_MILLIS);<a name="line.420"></a>
<span class="sourceLineNo">421</span>        if (value != null) {<a name="line.421"></a>
<span class="sourceLineNo">422</span>            dataSource.setSoftMinEvictableIdleTimeMillis(Long.parseLong(value));<a name="line.422"></a>
<span class="sourceLineNo">423</span>        }<a name="line.423"></a>
<span class="sourceLineNo">424</span><a name="line.424"></a>
<span class="sourceLineNo">425</span>        value = properties.getProperty(PROP_EVICTION_POLICY_CLASS_NAME);<a name="line.425"></a>
<span class="sourceLineNo">426</span>        if (value != null) {<a name="line.426"></a>
<span class="sourceLineNo">427</span>            dataSource.setEvictionPolicyClassName(value);<a name="line.427"></a>
<span class="sourceLineNo">428</span>        }<a name="line.428"></a>
<span class="sourceLineNo">429</span><a name="line.429"></a>
<span class="sourceLineNo">430</span>        value = properties.getProperty(PROP_TEST_WHILE_IDLE);<a name="line.430"></a>
<span class="sourceLineNo">431</span>        if (value != null) {<a name="line.431"></a>
<span class="sourceLineNo">432</span>            dataSource.setTestWhileIdle(Boolean.valueOf(value).booleanValue());<a name="line.432"></a>
<span class="sourceLineNo">433</span>        }<a name="line.433"></a>
<span class="sourceLineNo">434</span><a name="line.434"></a>
<span class="sourceLineNo">435</span>        value = properties.getProperty(PROP_PASSWORD);<a name="line.435"></a>
<span class="sourceLineNo">436</span>        if (value != null) {<a name="line.436"></a>
<span class="sourceLineNo">437</span>            dataSource.setPassword(value);<a name="line.437"></a>
<span class="sourceLineNo">438</span>        }<a name="line.438"></a>
<span class="sourceLineNo">439</span><a name="line.439"></a>
<span class="sourceLineNo">440</span>        value = properties.getProperty(PROP_URL);<a name="line.440"></a>
<span class="sourceLineNo">441</span>        if (value != null) {<a name="line.441"></a>
<span class="sourceLineNo">442</span>            dataSource.setUrl(value);<a name="line.442"></a>
<span class="sourceLineNo">443</span>        }<a name="line.443"></a>
<span class="sourceLineNo">444</span><a name="line.444"></a>
<span class="sourceLineNo">445</span>        value = properties.getProperty(PROP_USER_NAME);<a name="line.445"></a>
<span class="sourceLineNo">446</span>        if (value != null) {<a name="line.446"></a>
<span class="sourceLineNo">447</span>            dataSource.setUsername(value);<a name="line.447"></a>
<span class="sourceLineNo">448</span>        }<a name="line.448"></a>
<span class="sourceLineNo">449</span><a name="line.449"></a>
<span class="sourceLineNo">450</span>        value = properties.getProperty(PROP_VALIDATION_QUERY);<a name="line.450"></a>
<span class="sourceLineNo">451</span>        if (value != null) {<a name="line.451"></a>
<span class="sourceLineNo">452</span>            dataSource.setValidationQuery(value);<a name="line.452"></a>
<span class="sourceLineNo">453</span>        }<a name="line.453"></a>
<span class="sourceLineNo">454</span><a name="line.454"></a>
<span class="sourceLineNo">455</span>        value = properties.getProperty(PROP_VALIDATION_QUERY_TIMEOUT);<a name="line.455"></a>
<span class="sourceLineNo">456</span>        if (value != null) {<a name="line.456"></a>
<span class="sourceLineNo">457</span>            dataSource.setValidationQueryTimeout(Integer.parseInt(value));<a name="line.457"></a>
<span class="sourceLineNo">458</span>        }<a name="line.458"></a>
<span class="sourceLineNo">459</span><a name="line.459"></a>
<span class="sourceLineNo">460</span>        value = properties.getProperty(PROP_ACCESS_TO_UNDERLYING_CONNECTION_ALLOWED);<a name="line.460"></a>
<span class="sourceLineNo">461</span>        if (value != null) {<a name="line.461"></a>
<span class="sourceLineNo">462</span>            dataSource.setAccessToUnderlyingConnectionAllowed(Boolean.valueOf(value).booleanValue());<a name="line.462"></a>
<span class="sourceLineNo">463</span>        }<a name="line.463"></a>
<span class="sourceLineNo">464</span><a name="line.464"></a>
<span class="sourceLineNo">465</span>        value = properties.getProperty(PROP_REMOVE_ABANDONED_ON_BORROW);<a name="line.465"></a>
<span class="sourceLineNo">466</span>        if (value != null) {<a name="line.466"></a>
<span class="sourceLineNo">467</span>            dataSource.setRemoveAbandonedOnBorrow(Boolean.valueOf(value).booleanValue());<a name="line.467"></a>
<span class="sourceLineNo">468</span>        }<a name="line.468"></a>
<span class="sourceLineNo">469</span><a name="line.469"></a>
<span class="sourceLineNo">470</span>        value = properties.getProperty(PROP_REMOVE_ABANDONED_ON_MAINTENANCE);<a name="line.470"></a>
<span class="sourceLineNo">471</span>        if (value != null) {<a name="line.471"></a>
<span class="sourceLineNo">472</span>            dataSource.setRemoveAbandonedOnMaintenance(Boolean.valueOf(value).booleanValue());<a name="line.472"></a>
<span class="sourceLineNo">473</span>        }<a name="line.473"></a>
<span class="sourceLineNo">474</span><a name="line.474"></a>
<span class="sourceLineNo">475</span>        value = properties.getProperty(PROP_REMOVE_ABANDONED_TIMEOUT);<a name="line.475"></a>
<span class="sourceLineNo">476</span>        if (value != null) {<a name="line.476"></a>
<span class="sourceLineNo">477</span>            dataSource.setRemoveAbandonedTimeout(Integer.parseInt(value));<a name="line.477"></a>
<span class="sourceLineNo">478</span>        }<a name="line.478"></a>
<span class="sourceLineNo">479</span><a name="line.479"></a>
<span class="sourceLineNo">480</span>        value = properties.getProperty(PROP_LOG_ABANDONED);<a name="line.480"></a>
<span class="sourceLineNo">481</span>        if (value != null) {<a name="line.481"></a>
<span class="sourceLineNo">482</span>            dataSource.setLogAbandoned(Boolean.valueOf(value).booleanValue());<a name="line.482"></a>
<span class="sourceLineNo">483</span>        }<a name="line.483"></a>
<span class="sourceLineNo">484</span><a name="line.484"></a>
<span class="sourceLineNo">485</span>        value = properties.getProperty(PROP_ABANDONED_USAGE_TRACKING);<a name="line.485"></a>
<span class="sourceLineNo">486</span>        if (value != null) {<a name="line.486"></a>
<span class="sourceLineNo">487</span>            dataSource.setAbandonedUsageTracking(Boolean.valueOf(value).booleanValue());<a name="line.487"></a>
<span class="sourceLineNo">488</span>        }<a name="line.488"></a>
<span class="sourceLineNo">489</span><a name="line.489"></a>
<span class="sourceLineNo">490</span>        value = properties.getProperty(PROP_POOL_PREPARED_STATEMENTS);<a name="line.490"></a>
<span class="sourceLineNo">491</span>        if (value != null) {<a name="line.491"></a>
<span class="sourceLineNo">492</span>            dataSource.setPoolPreparedStatements(Boolean.valueOf(value).booleanValue());<a name="line.492"></a>
<span class="sourceLineNo">493</span>        }<a name="line.493"></a>
<span class="sourceLineNo">494</span><a name="line.494"></a>
<span class="sourceLineNo">495</span>        value = properties.getProperty(PROP_CLEAR_STATEMENT_POOL_ON_RETURN);<a name="line.495"></a>
<span class="sourceLineNo">496</span>        if (value != null) {<a name="line.496"></a>
<span class="sourceLineNo">497</span>            dataSource.setClearStatementPoolOnReturn(Boolean.valueOf(value).booleanValue());<a name="line.497"></a>
<span class="sourceLineNo">498</span>        }<a name="line.498"></a>
<span class="sourceLineNo">499</span><a name="line.499"></a>
<span class="sourceLineNo">500</span>        value = properties.getProperty(PROP_MAX_OPEN_PREPARED_STATEMENTS);<a name="line.500"></a>
<span class="sourceLineNo">501</span>        if (value != null) {<a name="line.501"></a>
<span class="sourceLineNo">502</span>            dataSource.setMaxOpenPreparedStatements(Integer.parseInt(value));<a name="line.502"></a>
<span class="sourceLineNo">503</span>        }<a name="line.503"></a>
<span class="sourceLineNo">504</span><a name="line.504"></a>
<span class="sourceLineNo">505</span>        value = properties.getProperty(PROP_CONNECTION_INIT_SQLS);<a name="line.505"></a>
<span class="sourceLineNo">506</span>        if (value != null) {<a name="line.506"></a>
<span class="sourceLineNo">507</span>            dataSource.setConnectionInitSqls(parseList(value, ';'));<a name="line.507"></a>
<span class="sourceLineNo">508</span>        }<a name="line.508"></a>
<span class="sourceLineNo">509</span><a name="line.509"></a>
<span class="sourceLineNo">510</span>        value = properties.getProperty(PROP_CONNECTION_PROPERTIES);<a name="line.510"></a>
<span class="sourceLineNo">511</span>        if (value != null) {<a name="line.511"></a>
<span class="sourceLineNo">512</span>            final Properties p = getProperties(value);<a name="line.512"></a>
<span class="sourceLineNo">513</span>            final Enumeration&lt;?&gt; e = p.propertyNames();<a name="line.513"></a>
<span class="sourceLineNo">514</span>            while (e.hasMoreElements()) {<a name="line.514"></a>
<span class="sourceLineNo">515</span>                final String propertyName = (String) e.nextElement();<a name="line.515"></a>
<span class="sourceLineNo">516</span>                dataSource.addConnectionProperty(propertyName, p.getProperty(propertyName));<a name="line.516"></a>
<span class="sourceLineNo">517</span>            }<a name="line.517"></a>
<span class="sourceLineNo">518</span>        }<a name="line.518"></a>
<span class="sourceLineNo">519</span><a name="line.519"></a>
<span class="sourceLineNo">520</span>        value = properties.getProperty(PROP_MAX_CONN_LIFETIME_MILLIS);<a name="line.520"></a>
<span class="sourceLineNo">521</span>        if (value != null) {<a name="line.521"></a>
<span class="sourceLineNo">522</span>            dataSource.setMaxConnLifetimeMillis(Long.parseLong(value));<a name="line.522"></a>
<span class="sourceLineNo">523</span>        }<a name="line.523"></a>
<span class="sourceLineNo">524</span><a name="line.524"></a>
<span class="sourceLineNo">525</span>        value = properties.getProperty(PROP_LOG_EXPIRED_CONNECTIONS);<a name="line.525"></a>
<span class="sourceLineNo">526</span>        if (value != null) {<a name="line.526"></a>
<span class="sourceLineNo">527</span>            dataSource.setLogExpiredConnections(Boolean.valueOf(value).booleanValue());<a name="line.527"></a>
<span class="sourceLineNo">528</span>        }<a name="line.528"></a>
<span class="sourceLineNo">529</span><a name="line.529"></a>
<span class="sourceLineNo">530</span>        value = properties.getProperty(PROP_JMX_NAME);<a name="line.530"></a>
<span class="sourceLineNo">531</span>        if (value != null) {<a name="line.531"></a>
<span class="sourceLineNo">532</span>            dataSource.setJmxName(value);<a name="line.532"></a>
<span class="sourceLineNo">533</span>        }<a name="line.533"></a>
<span class="sourceLineNo">534</span><a name="line.534"></a>
<span class="sourceLineNo">535</span>        value = properties.getProperty(PROP_ENABLE_AUTO_COMMIT_ON_RETURN);<a name="line.535"></a>
<span class="sourceLineNo">536</span>        if (value != null) {<a name="line.536"></a>
<span class="sourceLineNo">537</span>            dataSource.setAutoCommitOnReturn(Boolean.valueOf(value).booleanValue());<a name="line.537"></a>
<span class="sourceLineNo">538</span>        }<a name="line.538"></a>
<span class="sourceLineNo">539</span><a name="line.539"></a>
<span class="sourceLineNo">540</span>        value = properties.getProperty(PROP_ROLLBACK_ON_RETURN);<a name="line.540"></a>
<span class="sourceLineNo">541</span>        if (value != null) {<a name="line.541"></a>
<span class="sourceLineNo">542</span>            dataSource.setRollbackOnReturn(Boolean.valueOf(value).booleanValue());<a name="line.542"></a>
<span class="sourceLineNo">543</span>        }<a name="line.543"></a>
<span class="sourceLineNo">544</span><a name="line.544"></a>
<span class="sourceLineNo">545</span>        value = properties.getProperty(PROP_DEFAULT_QUERY_TIMEOUT);<a name="line.545"></a>
<span class="sourceLineNo">546</span>        if (value != null) {<a name="line.546"></a>
<span class="sourceLineNo">547</span>            dataSource.setDefaultQueryTimeout(Integer.valueOf(value));<a name="line.547"></a>
<span class="sourceLineNo">548</span>        }<a name="line.548"></a>
<span class="sourceLineNo">549</span><a name="line.549"></a>
<span class="sourceLineNo">550</span>        value = properties.getProperty(PROP_FAST_FAIL_VALIDATION);<a name="line.550"></a>
<span class="sourceLineNo">551</span>        if (value != null) {<a name="line.551"></a>
<span class="sourceLineNo">552</span>            dataSource.setFastFailValidation(Boolean.valueOf(value).booleanValue());<a name="line.552"></a>
<span class="sourceLineNo">553</span>        }<a name="line.553"></a>
<span class="sourceLineNo">554</span><a name="line.554"></a>
<span class="sourceLineNo">555</span>        value = properties.getProperty(PROP_DISCONNECTION_SQL_CODES);<a name="line.555"></a>
<span class="sourceLineNo">556</span>        if (value != null) {<a name="line.556"></a>
<span class="sourceLineNo">557</span>            dataSource.setDisconnectionSqlCodes(parseList(value, ','));<a name="line.557"></a>
<span class="sourceLineNo">558</span>        }<a name="line.558"></a>
<span class="sourceLineNo">559</span><a name="line.559"></a>
<span class="sourceLineNo">560</span>        value = properties.getProperty(PROP_CONNECTION_FACTORY_CLASS_NAME);<a name="line.560"></a>
<span class="sourceLineNo">561</span>        if (value != null) {<a name="line.561"></a>
<span class="sourceLineNo">562</span>            dataSource.setConnectionFactoryClassName(value);<a name="line.562"></a>
<span class="sourceLineNo">563</span>        }<a name="line.563"></a>
<span class="sourceLineNo">564</span><a name="line.564"></a>
<span class="sourceLineNo">565</span>        // DBCP-215<a name="line.565"></a>
<span class="sourceLineNo">566</span>        // Trick to make sure that initialSize connections are created<a name="line.566"></a>
<span class="sourceLineNo">567</span>        if (dataSource.getInitialSize() &gt; 0) {<a name="line.567"></a>
<span class="sourceLineNo">568</span>            dataSource.getLogWriter();<a name="line.568"></a>
<span class="sourceLineNo">569</span>        }<a name="line.569"></a>
<span class="sourceLineNo">570</span><a name="line.570"></a>
<span class="sourceLineNo">571</span>        // Return the configured DataSource instance<a name="line.571"></a>
<span class="sourceLineNo">572</span>        return dataSource;<a name="line.572"></a>
<span class="sourceLineNo">573</span>    }<a name="line.573"></a>
<span class="sourceLineNo">574</span><a name="line.574"></a>
<span class="sourceLineNo">575</span>    /**<a name="line.575"></a>
<span class="sourceLineNo">576</span>     * &lt;p&gt;<a name="line.576"></a>
<span class="sourceLineNo">577</span>     * Parse properties from the string. Format of the string must be [propertyName=property;]*<a name="line.577"></a>
<span class="sourceLineNo">578</span>     * &lt;p&gt;<a name="line.578"></a>
<span class="sourceLineNo">579</span>     *<a name="line.579"></a>
<span class="sourceLineNo">580</span>     * @param propText<a name="line.580"></a>
<span class="sourceLineNo">581</span>     * @return Properties<a name="line.581"></a>
<span class="sourceLineNo">582</span>     * @throws Exception<a name="line.582"></a>
<span class="sourceLineNo">583</span>     */<a name="line.583"></a>
<span class="sourceLineNo">584</span>    private static Properties getProperties(final String propText) throws Exception {<a name="line.584"></a>
<span class="sourceLineNo">585</span>        final Properties p = new Properties();<a name="line.585"></a>
<span class="sourceLineNo">586</span>        if (propText != null) {<a name="line.586"></a>
<span class="sourceLineNo">587</span>            p.load(new ByteArrayInputStream(propText.replace(';', '\n').getBytes(StandardCharsets.ISO_8859_1)));<a name="line.587"></a>
<span class="sourceLineNo">588</span>        }<a name="line.588"></a>
<span class="sourceLineNo">589</span>        return p;<a name="line.589"></a>
<span class="sourceLineNo">590</span>    }<a name="line.590"></a>
<span class="sourceLineNo">591</span><a name="line.591"></a>
<span class="sourceLineNo">592</span>    /**<a name="line.592"></a>
<span class="sourceLineNo">593</span>     * Parse list of property values from a delimited string<a name="line.593"></a>
<span class="sourceLineNo">594</span>     *<a name="line.594"></a>
<span class="sourceLineNo">595</span>     * @param value<a name="line.595"></a>
<span class="sourceLineNo">596</span>     *            delimited list of values<a name="line.596"></a>
<span class="sourceLineNo">597</span>     * @param delimiter<a name="line.597"></a>
<span class="sourceLineNo">598</span>     *            character used to separate values in the list<a name="line.598"></a>
<span class="sourceLineNo">599</span>     * @return String Collection of values<a name="line.599"></a>
<span class="sourceLineNo">600</span>     */<a name="line.600"></a>
<span class="sourceLineNo">601</span>    private static Collection&lt;String&gt; parseList(final String value, final char delimiter) {<a name="line.601"></a>
<span class="sourceLineNo">602</span>        final StringTokenizer tokenizer = new StringTokenizer(value, Character.toString(delimiter));<a name="line.602"></a>
<span class="sourceLineNo">603</span>        final Collection&lt;String&gt; tokens = new ArrayList&lt;&gt;(tokenizer.countTokens());<a name="line.603"></a>
<span class="sourceLineNo">604</span>        while (tokenizer.hasMoreTokens()) {<a name="line.604"></a>
<span class="sourceLineNo">605</span>            tokens.add(tokenizer.nextToken());<a name="line.605"></a>
<span class="sourceLineNo">606</span>        }<a name="line.606"></a>
<span class="sourceLineNo">607</span>        return tokens;<a name="line.607"></a>
<span class="sourceLineNo">608</span>    }<a name="line.608"></a>
<span class="sourceLineNo">609</span>}<a name="line.609"></a>




























































</pre>
</div>
</body>
</html>
